from functools import wraps

def trace(name):
    def decorator(f):
        @wraps(f)
        def wrapper(*args, **kw):
            try:
                print("=> entering %s" % name)
                return f(*args, **kw)
            finally:
                print("<= leaving %s" % name)

        return wrapper
    return decorator

@trace("sum")
def sum(a, b):
    return a + b

print(sum)
print(sum(2, 2))

